=== parsing_cocci/tests/Makefile ===
all: 1.output 2.output 3.output 4.output 5.output 6.output 7.output \
8.output 9.output 10.output 11.output 12.output 13.output 14.output \
15.output 16.output 17.output 18.output 19.output 20.output 21.output \
22.output 23.output 24.output 25.output 26.output 27.output 28.output \
29.output 30.output 

1.output: 1.cocci ../cocci_parser
	../cocci_parser 1.cocci > 1.output
2.output: 2.cocci ../cocci_parser
	../cocci_parser 2.cocci > 2.output
3.output: 3.cocci ../cocci_parser
	../cocci_parser 3.cocci > 3.output
4.output: 4.cocci ../cocci_parser
	../cocci_parser 4.cocci > 4.output
5.output: 5.cocci ../cocci_parser
	../cocci_parser 5.cocci > 5.output
6.output: 6.cocci ../cocci_parser
	../cocci_parser 6.cocci > 6.output
7.output: 7.cocci ../cocci_parser
	../cocci_parser 7.cocci > 7.output
8.output: 8.cocci ../cocci_parser
	../cocci_parser 8.cocci > 8.output
9.output: 9.cocci ../cocci_parser
	../cocci_parser 9.cocci > 9.output
10.output: 10.cocci ../cocci_parser
	../cocci_parser 10.cocci > 10.output
11.output: 11.cocci ../cocci_parser
	../cocci_parser 11.cocci > 11.output
12.output: 12.cocci ../cocci_parser
	../cocci_parser 12.cocci > 12.output
13.output: 13.cocci ../cocci_parser
	../cocci_parser 13.cocci > 13.output
14.output: 14.cocci ../cocci_parser
	../cocci_parser 14.cocci > 14.output
15.output: 15.cocci ../cocci_parser
	../cocci_parser 15.cocci > 15.output
16.output: 16.cocci ../cocci_parser
	../cocci_parser 16.cocci > 16.output
17.output: 17.cocci ../cocci_parser
	../cocci_parser 17.cocci > 17.output
18.output: 18.cocci ../cocci_parser
	../cocci_parser 18.cocci > 18.output
19.output: 19.cocci ../cocci_parser
	../cocci_parser 19.cocci > 19.output
20.output: 20.cocci ../cocci_parser
	../cocci_parser 20.cocci > 20.output
21.output: 21.cocci ../cocci_parser
	../cocci_parser 21.cocci > 21.output
22.output: 22.cocci ../cocci_parser
	../cocci_parser 22.cocci > 22.output
23.output: 23.cocci ../cocci_parser
	../cocci_parser 23.cocci > 23.output
24.output: 24.cocci ../cocci_parser
	../cocci_parser 24.cocci > 24.output
25.output: 25.cocci ../cocci_parser
	../cocci_parser 25.cocci > 25.output
26.output: 26.cocci ../cocci_parser
	../cocci_parser 26.cocci > 26.output
27.output: 27.cocci ../cocci_parser
	../cocci_parser 27.cocci > 27.output
28.output: 28.cocci ../cocci_parser
	../cocci_parser 28.cocci > 28.output
29.output: 29.cocci ../cocci_parser
	../cocci_parser 29.cocci > 29.output
30.output: 30.cocci ../cocci_parser
	../cocci_parser 30.cocci > 30.output

clean:
	/bin/rm ?.output ??.output
