=== debian/changelog ===
coccinelle (0.2.0.deb-1ubuntu2) lucid; urgency=low

  * No-change rebuild for OCaml 3.11.2 transition (LP: #529408).

 -- Ilya Barygin <barygin@gmail.com>  Sun, 28 Feb 2010 20:02:48 +0300

coccinelle (0.2.0.deb-1ubuntu1) lucid; urgency=low

  * Merge from debian testing (LP: #515198).Remaining changes:
    - debian/control: build-depend on python2.6-dev,
      set XB-Python-Version to 2.6

 -- Bhavani Shankar <right2bhavi@gmail.com>  Sun, 31 Jan 2010 22:30:19 +0530

coccinelle (0.2.0.deb-1) unstable; urgency=low

  * New upstream release
  * Do not use topgit and quilt. Convert package to source format 3.0 (quilt) 
  * Updated patches:
    - system-menhir.diff
    - system-ocamlsexp.diff
    - system-pycaml.diff
  * Use dh overrides in debian/rules
  * Update debian/watch

 -- Євгеній Мещеряков <eugen@debian.org>  Tue, 19 Jan 2010 23:43:44 +0100

coccinelle (0.1.10.deb-1ubuntu1) lucid; urgency=low

  * Merge from Debian unstable, remaining changes:
    - debian/control: build-depend on python2.6-dev,
      set XB-Python-Version to 2.6

 -- Daniel T Chen <crimsun@ubuntu.com>  Tue, 08 Sep 2009 13:06:20 +0100

coccinelle (0.1.10.deb-1) unstable; urgency=low

  * New upstream release
  * Updated patches:
    - fixes/system-pycaml 
  * Standards-Version 3.8.3 — no changes required

 -- Євгеній Мещеряков <eugen@debian.org>  Tue, 08 Sep 2009 01:37:43 +0200

coccinelle (0.1.9.deb-1ubuntu1) karmic; urgency=low

  * Merge from Debian unstable, remaining changes:
    - debian/control: build-depend on python2.6-dev,
      set XB-Python-Version to 2.6
  * New upstream (Debian) packaging applied fix for
    LP: #410907 (see changelog entry below)

 -- Daniel T Chen <crimsun@ubuntu.com>  Mon, 10 Aug 2009 01:01:24 +0100

coccinelle (0.1.9.deb-1) unstable; urgency=low

  * New upstream release
  * Update debian/repack.sh
  * Update upstream homepage and watch file, thanks to Daniel T Chen
    (closes: #540580)
  * Removed patches:
    - fixes/unsafe-tmp-handling - fixed upstream
  * Updated patches:
    - fixes/system-ocamlsexp
  * Standards-version 3.8.2 - no changes needed

 -- Євгеній Мещеряков <eugen@debian.org>  Sun, 09 Aug 2009 20:54:57 +0200

coccinelle (0.1.8.deb-4ubuntu1) karmic; urgency=low

  * debian/control: python2.6 transition: (LP: #390746)
     - build-depend to python2.6-dev instead of python2.5-dev.
     - set XB-Python-Version to 2.6.

 -- Andrea Gasparini <gaspa@yattaweb.it>  Mon, 22 Jun 2009 17:37:54 +0200

coccinelle (0.1.8.deb-4) unstable; urgency=low

  * Fix bytecode builds
  * Swap order of patches fixes/system-pycaml <-> fixes/system-menhir

 -- Євгеній Мещеряков <eugen@debian.org>  Fri, 12 Jun 2009 13:27:18 +0200

coccinelle (0.1.8.deb-3) unstable; urgency=low

  * Fix FTBFS with newer pycaml
  * Updated patch:
    - fixes/system-pycaml

 -- Євгеній Мещеряков <eugen@debian.org>  Fri, 12 Jun 2009 00:54:27 +0200

coccinelle (0.1.8.deb-2) unstable; urgency=low

  * Use common install Makefile target for both native and bytecode
    build. This hopefully fixes FTBFS on bytecode archs 

 -- Євгеній Мещеряков <eugen@debian.org>  Mon, 11 May 2009 15:32:24 +0200

coccinelle (0.1.8.deb-1) unstable; urgency=low

  * New upstream release
  * Update debian/repack.sh
    - remove docs/manual directory (GFDL)
  * New patch:
    - fixes/documentation-build 
  * Don't build documentation
  * Don't suggest doc-base and build-depend on texlive packages

 -- Євгеній Мещеряков <eugen@debian.org>  Mon, 11 May 2009 14:27:45 +0200

coccinelle (0.1.7.deb-3) unstable; urgency=high

  * New patch:
    - fixes/unsafe-tmp-handling - disable creating result file
      in /tmp. This was done without any checks for symlinks,
      so this is security bug (CVE-2009-1753).

 -- Євгеній Мещеряков <eugen@debian.org>  Sat, 02 May 2009 01:58:20 +0200

coccinelle (0.1.7.deb-2) unstable; urgency=low

  * Fix typo in debian/spatch

 -- Євгеній Мещеряков <eugen@debian.org>  Sat, 18 Apr 2009 02:31:07 +0200

coccinelle (0.1.7.deb-1) unstable; urgency=low

  * New upstream release
  * Removed patches:
    - fixes/clean-fixes
    - fixes/dont-overwrite-config 
  * New patches:
    - fixes/system-ocamlsexp - use Debian's ocamlsexp
  * Don't install glade file in debian/rules - fixed upstream
  * Build-depend on libsexplib-camlp4-dev
  * Build-depend on texlive-fonts-recommended

 -- Євгеній Мещеряков <eugen@debian.org>  Thu, 16 Apr 2009 21:56:02 +0200

coccinelle (0.1.6.deb+a-3) unstable; urgency=low

  * Upload to unstable
  * Fix build/install target dependencies. Also add workaround for
    bug #522906 in topgit (causes multiple runs of build-stamp target)
  * Install pygui.glade
  * Install cocci.el

 -- Євгеній Мещеряков <eugen@debian.org>  Sat, 11 Apr 2009 23:32:49 +0200

coccinelle (0.1.6.deb+a-2) experimental; urgency=low

  * Upload to experimental to let previous version migrate to testing
  * Fix Vcs-Browser URL
  * Compile to native code if possible
  * Git repository is now in pkg-ocaml-maint group. Adjust Vcs-* fields
  * Set maintainers to Debian OCaml Maintainers 
  * Add explicit list of topgit patches into debian/rules
  * Add tag-patches rule (tags topgit branches) 
  * Build-depend on python2.5-dev (needed for native compilation)
  * Build-depend on python-support (>= 0.6)

 -- Євгеній Мещеряков <eugen@debian.org>  Mon, 06 Apr 2009 17:03:01 +0200

coccinelle (0.1.6.deb+a-1) unstable; urgency=low

  * New upstream release
  * Do not move spatch executable from bindir to /usr/share/..., upstream
    Makefile already installs it there
  * Policy 3.8.1 — no changes required
  * Remove files matching .depend, .subdirs and .#* in debian/repack.sh
  * Pass --no-opt --with-python --without-trac to the configure script
    to make building more predictable
  * Remove files generated by the configure script in debian/repack.sh
  * Use topgit/quilt for packaging
  * Add Vcs-* fields to debian/control
  * Don't try to remove installed makefiles
  * Install examples

